#include "PushButton.h"

// in*.cpp -> IMPLEMENTATION OR LOGIC of the CLASS

// CONSTRUCTOR
PushButton::PushButton(byte pin) {
  _pin = pin;
}

PushButton::PushButton(byte pin, bool pullUp) {
  _pin = pin;
  _pullUp = pullUp;
}

PushButton::PushButton(byte pin, bool pullUp, bool deBounce) {
  _pin = pin;
  _pullUp = pullUp;
  _deBounce = deBounce;
  lastTimeStateChanged = millis();
  debounceDelay = 50;
}

// METHODS
void PushButton::init() {
  if (_pullUp) pinMode(_pin, INPUT_PULLUP);
  else pinMode(_pin, INPUT);
  state = digitalRead(_pin);
}

bool PushButton::readState() {
  if (!(_deBounce)) 
  {
    state = digitalRead(_pin);
  } 
  
  else 
  {
    unsigned long timeNow = millis();
    if (timeNow - lastTimeStateChanged > debounceDelay) {
      bool newState = digitalRead(_pin);
      if (newState != state) {
        state = newState;
        lastTimeStateChanged = timeNow;
      }
    }
  }
  return state;
}

bool PushButton::isPressed() {
  readState();
  if (_pullUp) return !state;
  else return state;
}

