#include "LedBlinker.h"

LedBlinker::LedBlinker(Led &led) // constructor //&led = by reference 
{
  _led = led;
  lastTimeBlinked = millis();
  _blinkDelay = 500;


}

LedBlinker::LedBlinker(Led &led, unsigned long blinkDelay) // Overload constructor
{
  _led = led;
  lastTimeBlinked = millis();
  _blinkDelay = blinkDelay;
}


void LedBlinker::initLed()
{
  _led.init();   // Functie die in classe Led zit-> let op de underscore voor _led

}

void LedBlinker::toggleLed()
{
  _led.toggle(); // Functie die in classe Led zit-> let op de underscore voor _led
}

bool LedBlinker::isPoweredOnLed()
{
  _led.isPoweredOn(); // Functie die in classe Led zit-> let op de underscore voor _led
}

void LedBlinker::update()
{
  unsigned long timeNow = millis();
  if (timeNow - lastTimeBlinked > _blinkDelay) {
    lastTimeBlinked = timeNow;
    toggleLed();
  }
}

// GETTER METHODE
unsigned long LedBlinker::getBlinkDelay()
{
  return _blinkDelay;
}

// SETTER METHODE
void LedBlinker::setBlinkDelay(unsigned long blinkDelay)
{
  _blinkDelay = blinkDelay;
}



