#include "Led.h"

Led::Led(byte pin)
{
  _pin = pin;
  state = LOW;
}

void Led::init()
{
  pinMode(_pin, OUTPUT);
}

void Led::init(bool defaultState)
{
  init();
  if (defaultState) {
    on();
  }
  else {
    off();
  }
}

void Led::on()
{
  state = HIGH;
  pinMode(_pin, OUTPUT);    // om pin na PWM functie terug als IO pin te zetten
  digitalWrite(_pin, HIGH);
}

void Led::off()
{
  state = LOW;
  pinMode(_pin, OUTPUT);    // om pin na PWM functie terug als IO pin te zetten
  digitalWrite(_pin, LOW);
}

void Led::on(byte brightness)
{
  state = HIGH;
  analogWrite(_pin, brightness);
}


bool Led::isPoweredOn()
{
  return state;
}

void Led::toggle()
{
  if (isPoweredOn()) {
    off();
  }
  else {
    on();
  }
}
