#ifndef TRAFFIC_LIGHT_H
#define TRAFFIC_LIGHT_H

#include "Led.h"
#include "LedBlinker.h"
#include "PushButton.h"
#include "Potentiometer.h"

class TrafficLight
{
private:
  Led _redLed;	// we roepen 3 objecten aan van de class ‘Led’ -> OVERERVING
  Led _yellowLed;
  Led _greenLed;
  LedBlinker _greenLedBlinker; // OVERERVING van class ‘LedBlinker’
  PushButton _button;		// OVERERVING van class ‘PushButton’
  Potentiometer _potentiometer;
  byte _ledsBrightness;

  enum trafficLightState {	 
    STATE_RED,
    STATE_YELLOW,
    STATE_GREEN,
    STATE_BLINK_GREEN
  };					//Enum instructie om logische namen te kunnen
// gebruiken ipv getallen. 
  int state;		// om de getallen – zie enum hierboven  – in te onthouden

  unsigned long yellowStateStartTime;
  unsigned long greenStateStartTime;
  unsigned long blinkGreenStateStartTime;

  const int yellowStateDuration = 3000;
  const int greenStateDuration = 2000;
  const int blinkGreenStateDuration = 3000;

  void updateLedsBrightness();

public:
  TrafficLight() {} // do not use
  TrafficLight(
    Led &redLed, Led &yellowLed, Led &greenLed,
    LedBlinker &greenLedBlinker, PushButton &button, Potentiometer &potentiometer); // Constructor van samengestelde OVERERVING classes

  void init();

  void red();
  void yellow();
  void green();
  void allLedsOff();
  void update();
  
};
#endif